<script setup lang="ts">
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { message, Modal, Form } from 'ant-design-vue/lib';
import { SizeType } from 'ant-design-vue/lib/config-provider';
import { MenuInfo } from 'ant-design-vue/lib/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/lib/table';
import UploadModal from '@/components/UploadModal/index.vue';
import {
  listRules,
  getRule,
  updateRule,
  addRule,
  delRule,
  exportRule,
  importRuleData,
  batchAddRule,
  batchDelRule,
  batchUpdateRule,
} from '@/api/neUser/pcf';
import useNeInfoStore from '@/store/modules/neinfo';
import useI18n from '@/hooks/useI18n';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import { saveAs } from 'file-saver';
import { uploadFileToNE } from '@/api/tool/file';
const { t } = useI18n();

/**网元参数 */
let neOtions = ref<Record<string, any>[]>([]);

/**查询参数 */
let queryParams = reactive({
  /**网元ID */
  neId: undefined,
  /**移动编号 */
  imsi: '',
  /**号码 */
  msisdn: '',
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    imsi: '',
    msisdn: '',
  });
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**斑马纹 */
  striped: boolean;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'small',
  striped: false,
  seached: true,
  data: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: 'IMSI',
    dataIndex: 'imsi',
    sorter: (a: any, b: any) => Number(a.imsi) - Number(b.imsi),
    align: 'center',
    width: 150,
  },
  {
    title: 'MSISDN',
    dataIndex: 'msisdn',
    sorter: (a: any, b: any) => Number(a.msisdn) - Number(b.msisdn),
    align: 'center',
    width: 150,
  },
  {
    title: 'SAR',
    dataIndex: 'sar',
    align: 'center',
    width: 80,
  },
  {
    title: 'RFSP',
    dataIndex: 'rfsp',
    align: 'center',
    width: 50,
  },
  {
    title: 'QOS Video',
    dataIndex: 'qosVideo',
    align: 'center',
    width: 100,
  },
  {
    title: 'QOS Audio',
    dataIndex: 'qosAudio',
    align: 'center',
    width: 100,
  },
  {
    title: 'PCC Rules',
    dataIndex: 'pccRules',
    align: 'center',
    width: 120,
  },
  {
    title: 'SESS Rules',
    dataIndex: 'sessRules',
    align: 'center',
    width: 120,
  },
  {
    title: 'HDR Enrich',
    dataIndex: 'hdrEnrich',
    align: 'center',
    width: 100,
  },
  {
    title: 'UE Policy',
    dataIndex: 'uePolicy',
    align: 'center',
    width: 100,
  },
  {
    title: t('common.operate'),
    key: 'imsi',
    align: 'left',
    width: 100,
  },
];

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格斑马纹 */
function fnTableStriped(_record: unknown, index: number): any {
  return tableState.striped && index % 2 === 1 ? 'table-striped' : undefined;
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  visibleByEdit: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**是否批量操作 */
  isBatch: boolean;
  /**操作类型 */
  type: 'delete' | 'add' | 'update';
  /**确定按钮 loading */
  confirmLoading: boolean;
  /**更新加载数据按钮 loading */
  loadDataLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  visibleByEdit: false,
  title: '用户策略',
  from: {
    num: 1,
    imsi: '',
    msisdn: '',
    qosAudio: '',
    pccRules: 'internet|ims_sig',
    rfsp: 0,
    uePolicy: '',
    sessRules: 'internet|ims_sig',
    sar: '',
    hdrEnrich: '',
    qosVideo: '',
  },
  isBatch: false,
  type: 'add',
  confirmLoading: false,
  loadDataLoading: false,
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    num: [
      {
        required: true,
        message: t('views.neUser.pcf.batchNum') + t('common.unableNull'),
      },
    ],
    imsi: [{ required: true, message: `IMSI ${t('common.unableNull')}` }],
    msisdn: [{ required: true, message: `MSISDN ${t('common.unableNull')}` }],
  })
);

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByEdit(row?: Record<string, any>) {
  modalState.isBatch = false;
  if (!row) {
    modalStateFrom.resetFields(); //重置表单
    modalState.title = t('views.neUser.pcf.addTitle');
    modalState.visibleByEdit = true;
    modalState.type = 'add';
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading(t('common.loading'), 0);
    modalState.confirmLoading = true;
    const neID = queryParams.neId || '-';
    getRule(neID, row.imsi)
      .then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          modalState.from = Object.assign(modalState.from, res.data);
          modalState.title = t('views.neUser.pcf.updateTitle', {
            imsi: row.imsi,
          });
          modalState.visibleByEdit = true;
          modalState.type = 'update';
        } else {
          message.error(t('common.getInfoFail'), 2);
        }
      })
      .finally(() => {
        hide();
        modalState.confirmLoading = false;
      });
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  const from = toRaw(modalState.from);
  from.neId = queryParams.neId || '-';
  from.rfsp = Number(from.rfsp) || 0;

  let validateArr = ['imsi', 'msisdn'];
  if (modalState.isBatch) {
    validateArr.push('num');
    if (modalState.type === 'delete') {
      validateArr = ['num', 'imsi'];
    }
  }

  modalStateFrom
    .validate(validateArr)
    .then(e => {
      modalState.confirmLoading = true;
      const hide = message.loading(t('common.loading'), 0);

      // 根据类型选择函数
      let result: any = null;
      if (modalState.isBatch) {
        if (modalState.type === 'add') {
          result = batchAddRule(from);
        }
        if (modalState.type === 'update') {
          result = batchUpdateRule(from);
        }
        if (modalState.type === 'delete') {
          result = batchDelRule(from);
        }
      } else {
        if (modalState.type === 'add') {
          result = addRule(from);
        }
        if (modalState.type === 'update') {
          result = updateRule(from);
        }
      }

      result
        .then((res: any) => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            fnModalCancel();
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.type = 'add';
  modalState.isBatch = false;
  modalState.visibleByEdit = false;
  modalStateFrom.resetFields();
}

/**
 * 对话框弹出显示为 批量操作
 * @param type 类型
 */
function fnModalVisibleByBatch(type: 'delete' | 'add' | 'update') {
  modalStateFrom.resetFields(); //重置表单
  modalState.isBatch = true;
  modalState.type = type;
  if (type === 'add') {
    modalState.title = t('views.neUser.pcf.batchAddText');
    modalState.visibleByEdit = true;
  }
  if (type === 'update') {
    modalState.title = t('views.neUser.pcf.batchUpdateText');
    modalState.visibleByEdit = true;
  }
  if (type === 'delete') {
    modalState.title = t('views.neUser.pcf.batchDelText');
    modalState.visibleByEdit = true;
  }
}

/**
 * 记录删除
 * @param row 网元编号ID
 */
function fnRecordDelete(row: Record<string, any>) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.neUser.pcf.delSure', { imsi: row.imsi }),
    onOk() {
      const key = 'delRule';
      message.loading({ content: t('common.loading'), key });
      const neID = queryParams.neId || '-';
      delRule(neID, row).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', {
              msg: row.imsi + t('common.deleteText'),
            }),
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key: key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**列表导出 */
function fnExportList(type: string) {
  const neID = queryParams.neId;
  if (!neID) return;
  const key = 'exportRule';
  message.loading({ content: t('common.loading'), key });
  exportRule({
    neId: neID,
    fileType: type,
  }).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      message.success({
        content: t('common.msgSuccess', { msg: t('common.export') }),
        key,
        duration: 2,
      });
      saveAs(res.data, `PCF_${neID}_${Date.now()}.${type}`);
    } else {
      message.error({
        content: `${res.msg}`,
        key,
        duration: 2,
      });
    }
  });
}

/**查询列表, pageNum初始页数 */
function fnGetList() {
  if (tableState.loading) return;
  tableState.loading = true;
  listRules(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      tableState.data = res.rows;
    } else {
      tableState.data = [];
    }
    tableState.loading = false;
  });
}

/**对话框表格信息导入对象信息状态类型 */
type ModalUploadImportStateType = {
  /**是否显示 */
  visible: boolean;
  /**标题 */
  title: string;
  /**是否上传中 */
  loading: boolean;
  /**上传结果信息 */
  msg: string;
};

/**对话框表格信息导入对象信息状态 */
let uploadImportState: ModalUploadImportStateType = reactive({
  visible: false,
  title: t('components.UploadModal.uploadTitle'),
  loading: false,
  msg: '',
});

/**对话框表格信息导入弹出窗口 */
function fnModalUploadImportOpen() {
  uploadImportState.msg = '';
  uploadImportState.loading = false;
  uploadImportState.visible = true;
}

/**对话框表格信息导入关闭窗口 */
function fnModalUploadImportClose() {
  uploadImportState.visible = false;
  fnGetList();
}

/**对话框表格信息导入上传 */
function fnModalUploadImportUpload(file: File) {
  const neID = queryParams.neId;
  if (!neID) {
    return Promise.reject('Unknown network element');
  }
  const hide = message.loading(t('common.loading'), 0);
  uploadImportState.loading = true;
  uploadFileToNE('PCF', neID, file, 5)
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS) {
        return importRuleData({
          neId: neID,
          filePath: res.data,
          fileType: 'txt',
        });
      }
      return res;
    })
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && res.data?.filePath) {
        uploadImportState.msg = t('views.neUser.pcf.uploadFileOk');
      } else if (res.code === RESULT_CODE_SUCCESS && res.data?.detail) {
        uploadImportState.msg = res.data?.detail;
      } else {
        uploadImportState.msg = t('views.neUser.pcf.uploadFileErr');
      }
    })
    .finally(() => {
      hide();
      uploadImportState.loading = false;
    });
}

onMounted(() => {
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        if (res.data.length > 0) {
          let arr: Record<string, any>[] = [];
          res.data.forEach(i => {
            if (i.neType === 'PCF') {
              arr.push({ value: i.neId, label: i.neName });
            }
          });
          neOtions.value = arr;
          if (arr.length > 0) {
            queryParams.neId = arr[0].value;
          }
        }
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      fnGetList();
    });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.neUser.pcf.neType')" name="neId ">
              <a-select
                v-model:value="queryParams.neId"
                :options="neOtions"
                :placeholder="t('common.selectPlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item label="IMSI" name="imsi">
              <a-input v-model:value="queryParams.imsi" allow-clear></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item label="MSISDN" name="msisdn">
              <a-input v-model:value="queryParams.msisdn" allow-clear></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList()">
                  <template #icon>
                    <SearchOutlined />
                  </template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon>
                    <ClearOutlined />
                  </template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <div class="button-container">
          <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
            <template #icon>
              <PlusOutlined />
            </template>
            {{ t('common.addText') }}
          </a-button>

          <a-button
            type="primary"
            ghost
            @click.prevent="fnModalVisibleByBatch('add')"
          >
            <template #icon>
              <PlusOutlined />
            </template>
            {{ t('views.neUser.pcf.batchAddText') }}
          </a-button>
          <a-button
            type="primary"
            ghost
            @click.prevent="fnModalVisibleByBatch('update')"
          >
            <template #icon>
              <FormOutlined />
            </template>
            {{ t('views.neUser.pcf.batchUpdateText') }}
          </a-button>
          <a-button
            type="primary"
            danger
            ghost
            @click.prevent="fnModalVisibleByBatch('delete')"
          >
            <template #icon>
              <DeleteOutlined />
            </template>
            {{ t('views.neUser.pcf.batchDelText') }}
          </a-button>

          <a-button type="dashed" @click.prevent="fnModalUploadImportOpen">
            <template #icon><ImportOutlined /></template>
            {{ t('views.neUser.pcf.import') }}
          </a-button>
          <a-popconfirm
            :title="t('views.neUser.pcf.exportConfirm')"
            ok-text="TXT"
            ok-type="default"
            @confirm="fnExportList('txt')"
            :show-cancel="false"
            cancel-text="CSV"
            @cancel="fnExportList('csv')"
          >
            <a-button type="dashed">
              <template #icon><ExportOutlined /></template>
              {{ t('views.neUser.pcf.export') }}
            </a-button>
          </a-popconfirm>
        </div>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <div class="button-container">
          <a-tooltip>
            <template #title>
              {{
                tableState.seached
                  ? t('common.switch.show')
                  : t('common.switch.hide')
              }}
            </template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.searchBarText')"
              :un-checked-children="t('common.searchBarText')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>
              {{
                tableState.striped
                  ? t('common.switch.show')
                  : t('common.switch.hide')
              }}
            </template>
            <a-switch
              v-model:checked="tableState.striped"
              :checked-children="t('common.zebra')"
              :un-checked-children="t('common.zebra')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </div>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="imsi"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :row-class-name="fnTableStriped"
        :pagination="false"
        :scroll="{ y: 'calc(100vh - 480px)' }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'imsi'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record)"
                >
                  <template #icon>
                    <FormOutlined />
                  </template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button type="link" @click.prevent="fnRecordDelete(record)">
                  <template #icon>
                    <DeleteOutlined />
                  </template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 新增框或修改框 -->
    <DraggableModal
      :width="modalState.type === 'delete' ? '500px' : '800px'"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFrom"
        layout="horizontal"
        :label-col="{ span: 6 }"
        :labelWrap="true"
      >
        <!--批量删除-->
        <template v-if="modalState.isBatch && modalState.type === 'delete'">
          <a-form-item
            :label="t('views.neUser.pcf.batchNum')"
            name="num"
            v-bind="modalStateFrom.validateInfos.num"
          >
            <a-input-number
              v-model:value="modalState.from.num"
              style="width: 100%"
              :min="1"
              :max="1000000"
              placeholder="<=1000000"
            ></a-input-number>
          </a-form-item>
          <a-form-item
            :label="
              modalState.isBatch ? t('views.neUser.pcf.startIMSI') : 'IMSI'
            "
            name="imsi"
            v-bind="modalStateFrom.validateInfos.imsi"
          >
            <a-input
              v-model:value="modalState.from.imsi"
              allow-clear
              :maxlength="64"
            >
              <template #prefix>
                <a-tooltip placement="topLeft">
                  <template #title>
                    {{ t('views.neUser.pcf.imsiTip') }}<br />
                    {{ t('views.neUser.pcf.imsiTip1') }}<br />
                    {{ t('views.neUser.pcf.imsiTip2') }}<br />
                    {{ t('views.neUser.pcf.imsiTip3') }}
                  </template>
                  <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                </a-tooltip>
              </template>
            </a-input>
          </a-form-item>
        </template>

        <template v-else>
          <!--批量数-->
          <a-row :gutter="16" v-if="modalState.isBatch">
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                :label="t('views.neUser.pcf.batchNum')"
                name="num"
                v-bind="modalStateFrom.validateInfos.num"
              >
                <a-input-number
                  v-model:value="modalState.from.num"
                  style="width: 100%"
                  :min="1"
                  :max="1000000"
                  placeholder="<=1000000"
                ></a-input-number>
              </a-form-item>
            </a-col>
          </a-row>

          <a-row :gutter="16">
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                :label="
                  modalState.isBatch ? t('views.neUser.pcf.startIMSI') : 'IMSI'
                "
                name="imsi"
                v-bind="modalStateFrom.validateInfos.imsi"
              >
                <a-input
                  v-model:value="modalState.from.imsi"
                  allow-clear
                  :maxlength="64"
                  :disabled="
                    !modalState.isBatch && modalState.type === 'update'
                  "
                >
                  <template #prefix>
                    <a-tooltip placement="topLeft">
                      <template #title>
                        {{ t('views.neUser.pcf.imsiTip') }}<br />
                        {{ t('views.neUser.pcf.imsiTip1') }}<br />
                        {{ t('views.neUser.pcf.imsiTip2') }}<br />
                        {{ t('views.neUser.pcf.imsiTip3') }}
                      </template>
                      <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                    </a-tooltip>
                  </template>
                </a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item
                label="MSISDN"
                name="msisdn"
                v-bind="modalStateFrom.validateInfos.msisdn"
              >
                <a-input
                  v-model:value="modalState.from.msisdn"
                  allow-clear
                  :maxlength="16"
                  :disabled="
                    !modalState.isBatch && modalState.type === 'update'
                  "
                >
                </a-input>
              </a-form-item>
            </a-col>
          </a-row>

          <a-row :gutter="16">
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item label="PCC Rules" name="pccRules">
                <a-input
                  v-model:value="modalState.from.pccRules"
                  allow-clear
                  :maxlength="64"
                >
                </a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item label="SESS Rules" name="sessRules">
                <a-input
                  v-model:value="modalState.from.sessRules"
                  allow-clear
                  :maxlength="64"
                >
                </a-input>
              </a-form-item>
            </a-col>
          </a-row>

          <a-row :gutter="16">
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item label="QOS Audio" name="qosAudio">
                <a-input
                  v-model:value="modalState.from.qosAudio"
                  allow-clear
                  :maxlength="64"
                >
                </a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item label="QOS Video" name="qosVideo">
                <a-input
                  v-model:value="modalState.from.qosVideo"
                  allow-clear
                  :maxlength="64"
                >
                </a-input>
              </a-form-item>
            </a-col>
          </a-row>

          <a-row :gutter="16">
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item label="HDR Enrich" name="hdrEnrich">
                <a-input
                  v-model:value="modalState.from.hdrEnrich"
                  allow-clear
                  :maxlength="64"
                >
                </a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item label="UE Policy" name="uePolicy">
                <a-input
                  v-model:value="modalState.from.uePolicy"
                  allow-clear
                  :maxlength="64"
                >
                </a-input>
              </a-form-item>
            </a-col>
          </a-row>

          <a-row :gutter="16">
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item label="Sar" name="sar">
                <a-input
                  v-model:value="modalState.from.sar"
                  allow-clear
                  :maxlength="64"
                >
                </a-input>
              </a-form-item>
            </a-col>
            <a-col :lg="12" :md="12" :xs="24">
              <a-form-item label="RFSP" name="rfsp">
                <a-input-number
                  v-model:value="modalState.from.rfsp"
                  style="width: 100%"
                  :min="0"
                  :max="255"
                  placeholder="0~255"
                ></a-input-number>
              </a-form-item>
            </a-col>
          </a-row>
        </template>
      </a-form>
    </DraggableModal>

    <!-- 上传导入表格数据文件框 -->
    <UploadModal
      :title="uploadImportState.title"
      :loading="uploadImportState.loading"
      @upload="fnModalUploadImportUpload"
      @close="fnModalUploadImportClose"
      v-model:visible="uploadImportState.visible"
      :ext="['.txt']"
    >
      <template #default>
        <a-textarea
          :disabled="true"
          :hidden="!uploadImportState.msg"
          :value="uploadImportState.msg"
          :auto-size="{ minRows: 2, maxRows: 8 }"
          style="background-color: transparent; color: rgba(0, 0, 0, 0.85)"
        />
      </template>
    </UploadModal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}

.table :deep(.table-striped) td {
  background-color: #fafafa;
}
</style>
